﻿;select events
Declare __GET_RGB_DNA(_str$)
Declare __SAVE_RGB_DNA(_str$)
Declare __SAVE_RGB_DNA_AS()

; Procedure __LOAD_AI42_FILE(_a42_file$)
; _a42_file$=OpenFileRequester(_open_file_title$,"","*ai42",0)


Procedure __WRITE_DEFAULT_DNA_DATA(_io_ok.l,_info.b)
;Define _def_max_gad.l=_max_gadgets.l
Define _def_start.l=1
Define _flip_flop.b=0

For _def_start.l=1 To _max_gadgets.l 


If _flip_flop=0
If GetGadgetText(_def_start)>""
WriteStringN(_io_ok.l,GetGadgetText(_def_start))
Else
WriteStringN(_io_ok.l,"")
EndIf
EndIf


If _flip_flop=1
If GetGadgetText(_def_start)>""
WriteStringN(_io_ok.l,GetGadgetText(_def_start))
Else
WriteStringN(_io_ok.l,"#")
EndIf
EndIf



_flip_flop.b=1-_flip_flop.b
Next

If _info.b=1
__ERROR_AI42(#_INFO_DEFAULT_DNA_DONE,_ai42_source$)
EndIf

EndProcedure


Procedure __RESET_DEFAULT_DNA()
 ;creates a standard ini file (ai42.ai42)
Define _io_ok.l=0

_io_ok.l=CreateFile(#PB_Any,_ai42_source$)

If _io_ok.l<>0

__WRITE_DEFAULT_DNA_DATA(_io_ok.l,1)

CloseFile(_io_ok.l)

Else

__ERROR_AI42(#_ERROR_CREATE_INI_AI42,_ai42_source$)

EndIf


EndProcedure
; EndProcedure

Procedure __CREATE_DEFAULT_DNA()
Define _check.l=0
;ask if we really want..
_check.l=MessageRequester("AI42 Internal Request:","Confirm If You Want To Reset `ai42.ai42´ DNA Data:", #PB_MessageRequester_YesNoCancel)
Select _check.l
Case #PB_MessageRequester_Yes
__RESET_DEFAULT_DNA()
EndSelect


EndProcedure

Procedure __LOAD_AI42_DNA(_a42_dna_file$)
_a42_dna_file$=OpenFileRequester(_open_file_title$,"","*",0)
__GET_RGB_DNA(_a42_dna_file$)

EndProcedure


Procedure __ASK_QUIT()
Define _button=0
_button.l=MessageRequester("                 AI42 QUESTION:               "," DO YOU WANT TO QUIT?"+Chr(10)+" ALL UNSAVED DATA WILL BE LOST",#PB_MessageRequester_YesNo)
If _button.l=#PB_MessageRequester_Yes
_quit_ai42=1  ;for now....
EndIf

EndProcedure

Procedure __GADGED_EVENT(_win_ai42_gad_event)

Select _win_ai42_gad_event

Case #_RGB_REQUESTER_GADGET
;nope

EndSelect



EndProcedure


Procedure __MENU_EVENTS(_event.l)

Select EventMenu()

Case #_MENUE_QUIT
__ASK_QUIT()

Case #_MENUE_LOAD_AI42
;__LOAD_AI42_FILE(_a42_file$)
__LOAD_AI42_DNA(_a42_dna_file$)
Case #_GET_RGB_DNA
__LOAD_AI42_DNA(_a42_dna_file$)

Case #_MENUE_SAVE_AS
__SAVE_RGB_DNA_AS()

Case #_MENUE_SAVE
__SAVE_RGB_DNA(_a42_dna_file$)

Case #_CREATE_INI_DNA_PATTERN
__CREATE_DEFAULT_DNA()

Case #_LOAD_DEFAULT_DNA
__GET_RGB_DNA(_ai42_source$)



EndSelect

EndProcedure


Procedure __SELECT_EVENT(_win_ai42_event)
Define _button.l=0


Select _win_ai42_event

Case #PB_Event_CloseWindow
__ASK_QUIT()
Case #PB_Event_Menu
__MENU_EVENTS(_win_ai42_event)

Case #PB_EventType_LostFocus
Delay(100) ;give max performance to host system

Case #PB_Event_Repaint   
;__SHOW_RGB(_r.l,_g.l,_b.l)

Case #PB_Event_Gadget
__GADGED_EVENT(EventGadget())
Default


EndSelect



EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 30
; FirstLine = 9
; Folding = --
; EnableXP
; EnableOnError
; CPU = 1
; SubSystem = DX9
; DisableDebugger
; HideErrorLog