﻿;eventhandler

Procedure __RGB_DITHER(_a.l,_b.l)
;here we try to reduce picture to 3 colour picture
Define _red.l=0
Define _blue.l=0
Define _green.l=0
Define _dither.b=0

_red.l=Red(Point(_a.l,_b.l))
_green.l=Green(Point(_a.l,_b.l))
_blue.l=Blue(Point(_a.l,_b.l))

;now select:

If _red.l/2>_green.l And _red.l/2>_blue
;red
Plot(_a.l,_b.l,RGB(255,000,000))
_dither.b=1
EndIf

If _green.l/2>_red.l And _green.l/2>_blue
;green
Plot(_a.l,_b.l,RGB(000,255,000))
_dither.b=1
EndIf


If _blue.l/2>_red.l And _blue.l/2>_green.l
;blue
Plot(_a.l,_b.l,RGB(000,000,255))
_dither.b=1
EndIf

If (_red.l+_green.l)>(_blue.l+_red.l) And (_red.l+_green.l)>(_blue.l+_green.l) And (_red.l+_green.l)>(_blue.l+_red.l)
;yellow
Plot(_a.l,_b.l,RGB(255,255,000))
_dither.b=1
EndIf

If _dither.b=0
Plot(_a.l,_b.l,RGB(000,000,000))  ;default for now, if no valid r/g/b data found...
EndIf


EndProcedure











Procedure   __MAKE_DUMMY_DLL(_dll_path$,_dll$)


Define _fio.l=0
Define _rfio.l=0


_rfio.l=ReadFile(#PB_Any,_dll_path$+_dll$+_codec$)

If _rfio.l=0
;yes! we need a new file (file is a ai24dna without file extension!!!!  : 012234050 for example! its a combination of R$+G$+B$)
    _fio.l=CreateFile(#PB_Any,_dll_path$+_dll$+_codec$)
    CloseFile(_fio.l)
Else

CloseFile(_rfio.l)  ;file already exist do NOT overwrite


EndIf


EndProcedure

Procedure  __MAKE_GREEN_MAP(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0

__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".green",0) =0
_rgb_map_path$+".green"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"GREEN-MAP-FILE:(C) Deutschmann Walter, Made Using RGB-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"GREEN-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f
  
  StartDrawing(ScreenOutput())
 For _b.l=0 To _h.f
     
     WriteStringN(_ofile.l,Str(Green(Point(_a.l,_b.l))))
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


; StartDrawing(ScreenOutput())
; ;now we draw a row structure over the picture:
; For i.l=0 To _my_window\w Step 2
; Box(i,0,1,_my_window\h,RGB(0,0,0))
; Next
; StopDrawing()


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into RGB()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)

__SET_STATE(#_WAITING)


EndProcedure



Procedure  __MAKE_BLUE_MAP(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0

__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".blue",0) =0
_rgb_map_path$+".blue"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"BLUE-MAP-FILE:(C) Deutschmann Walter, Made Using RGB-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"BLUE-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f
  
  StartDrawing(ScreenOutput())
 For _b.l=0 To _h.f
     
     WriteStringN(_ofile.l,Str(Blue(Point(_a.l,_b.l))))
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


; StartDrawing(ScreenOutput())
; ;now we draw a row structure over the picture:
; For i.l=0 To _my_window\w Step 2
; Box(i,0,1,_my_window\h,RGB(0,0,0))
; Next
; StopDrawing()


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into RGB()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)


EndProcedure




Procedure  __MAKE_RED_MAP(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0

__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".red",0) =0
_rgb_map_path$+".red"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"RED-MAP-FILE:(C) Deutschmann Walter, Made Using RGB-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"RED-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f
  
  StartDrawing(ScreenOutput())
 For _b.l=0 To _h.f
     
     WriteStringN(_ofile.l,Str(Red(Point(_a.l,_b.l))))
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


; StartDrawing(ScreenOutput())
; ;now we draw a row structure over the picture:
; For i.l=0 To _my_window\w Step 2
; Box(i,0,1,_my_window\h,RGB(0,0,0))
; Next
; StopDrawing()


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into RGB()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)


EndProcedure




Procedure  __MAKE_AI_MAP_DITHER(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0
Define _help$=""
Define _rgb$=""
Define _line_feed.b=0


__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".ai42",0)=0
_rgb_map_path$+".ai42"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"AI-FILE:(C) Deutschmann Walter, Made Using RGB-AI-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"AI-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f

  
StartDrawing(ScreenOutput())

For _b.l=0 To _h.f
_rgb$=""  ;used for dll(ai42 file dll)

     __RGB_DITHER(_a.l,_b.l)
     _help$=Str(Red(Point(_a.l,_b.l)))
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;RED
     _rgb$=_rgb$+_help$
     
     
     _help$=Str(Green(Point(_a.l,_b.l)))
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;GREEN
     _rgb$=_rgb$+_help$
         
     _help$=Str(Blue(Point(_a.l,_b.l)))
     
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;BLUE
     _rgb$=_rgb$+_help$
;       WriteString(_ofile.l,_rgb$)  ;use one line format: 000111222
;       
;             _line_feed+1
;             If _line_feed>31
;             WriteStringN(_ofile.l,"")
;            _line_feed=0
;            EndIf 
           
      __MAKE_DUMMY_DLL(_dll_path$,_rgb$)
   
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into AI()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)


EndProcedure

Procedure  __MAKE_AI_MAP(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0
Define _help$=""
Define _rgb$=""
Define _line_feed.b=0


__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".ai42",0)=0
_rgb_map_path$+".ai42"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"AI-FILE:(C) Deutschmann Walter, Made Using RGB-AI-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"AI-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f
  
StartDrawing(ScreenOutput())

For _b.l=0 To _h.f
_rgb$=""  ;used for dll(ai42 file dll)

    
     _help$=Str(Red(Point(_a.l,_b.l)))
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;RED
     _rgb$=_rgb$+_help$
     
     
     _help$=Str(Green(Point(_a.l,_b.l)))
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;GREEN
     _rgb$=_rgb$+_help$
         
     _help$=Str(Blue(Point(_a.l,_b.l)))
     
     If Len(_help$)<2
     _help$="00"+_help$
     EndIf
     
     If Len(_help$)<3
     _help$="0"+_help$
     EndIf
     WriteStringN(_ofile.l,_help$) ;BLUE
     _rgb$=_rgb$+_help$
;       WriteString(_ofile.l,_rgb$)  ;use one line format: 000111222
;       
;             _line_feed+1
;             If _line_feed>31
;             WriteStringN(_ofile.l,"")
;            _line_feed=0
;            EndIf 
           
      __MAKE_DUMMY_DLL(_dll_path$,_rgb$)
   
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into AI()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)


EndProcedure




Procedure  __MAKE_RGB_MAP(_w.f,_h.f,_rgb_map_path$)
;pic width & height
Define _ofile.l=0  ;openfile?
Define _a.l=0
Define _b.l=0

__SET_STATE(#_BUSSY)
If FindString(_rgb_map_path$,".rgb",0) =0
_rgb_map_path$+".rgb"
EndIf 

If _w.f>0 And _h.f>0 And _rgb_map_path$>""

_ofile.l=CreateFile(#PB_Any,_rgb_map_path$)

If _ofile.l
;header:

WriteStringN(_ofile.l,"RGB-MAP-FILE:(C) Deutschmann Walter, Made Using RGB-MAP-MAKER By Deutschmann Walter")
WriteStringN(_ofile.l,Str(_w.f))
WriteStringN(_ofile.l,Str(_h.f))
WriteStringN(_ofile.l,"SourceImage:"+_my_pic\file)
WriteStringN(_ofile.l,"RGB-DATA:")
EndIf

;now we catch the pixels....

For _a.l=0 To _w.f
  
  StartDrawing(ScreenOutput())
 For _b.l=0 To _h.f
     
     WriteStringN(_ofile.l,Str(Red(Point(_a.l,_b.l))))
     WriteStringN(_ofile.l,Str(Green(Point(_a.l,_b.l))))
     WriteStringN(_ofile.l,Str(Blue(Point(_a.l,_b.l))))
 Next 
 
   
   Plot(_a.l,_b.l,RGB(255,0,0))  ;progress...
   StopDrawing() 
   FlipBuffers()

Next


; StartDrawing(ScreenOutput())
; ;now we draw a row structure over the picture:
; For i.l=0 To _my_window\w Step 2
; Box(i,0,1,_my_window\h,RGB(0,0,0))
; Next
; StopDrawing()


If IsFile(_ofile.l)
CloseFile(_ofile.l)
EndIf


Else
MessageRequester("Error RGB()","No Image To Convert Into RGB()MAP",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)
ProcedureReturn  ;we do not show error requester???? ...
EndIf
MessageRequester("Info:","Image Converted!",#PB_MessageRequester_Ok)
__SET_STATE(#_WAITING)


EndProcedure



Procedure __EYE_RGB_SCAN()
;now cut it out.....
;use the backbuffer! do not flip!!!
If _my_pic\valid=1
ClearScreen(RGB(0,0,0))
DisplaySprite(_my_pic\sprite2d,0,0)
EndIf

EndProcedure


Procedure __ANALYSE_FILE(_a$)
Define _dummy.l

_dummy.l=LoadSprite(#PB_Any,_a$,#PB_Sprite_Texture)

If IsSprite(_dummy.l)
FreeSprite(_dummy.l)  ;kill dummy!
_my_pic\file=_a$
          
          TransparentSpriteColor(#PB_Default,RGB(255,255,0))
       
          If IsSprite(_my_pic\sprite2d)
          FreeSprite(_my_pic\sprite2d)
          EndIf
          
          
          _my_pic\sprite2d=LoadSprite(#PB_Any,_my_pic\file,#PB_Sprite_Texture)
          If IsSprite( _my_pic\sprite2d)
          _my_pic\w=SpriteWidth(_my_pic\sprite2d)
          _my_pic\h=SpriteHeight(_my_pic\sprite2d)
          _my_pic\valid=1
          EndIf

EndIf


EndProcedure


Procedure __SAVE_AI_DITHER()

_rgb_map\path=SaveFileRequester("SAVE AI MAP AS:",_rgb_map\path,"*.ai42",0)
If _rgb_map\path>""
        _dll_path$=PathRequester("PLEASE AI42 DESTINATION:",_rgb_map\path)
        
        If _dll_path$>""
       __MAKE_AI_MAP_DITHER(_my_pic\w,_my_pic\h,_rgb_map\path)
        EndIf
EndIf
EndProcedure

Procedure __SAVE_AI()

_rgb_map\path=SaveFileRequester("SAVE AI MAP AS:",_rgb_map\path,"*.ai42",0)
If _rgb_map\path>""
        _dll_path$=PathRequester("PLEASE AI42 DESTINATION:",_dll_path$)
        
        If _dll_path$>""
       __MAKE_AI_MAP(_my_pic\w,_my_pic\h,_rgb_map\path)
        EndIf
EndIf
EndProcedure


Procedure __SAVE_RGB()
_rgb_map\path=SaveFileRequester("SAVE RGB MAP AS...:",_rgb_map\path,"*.rgb",0)
If _rgb_map\path>""
__MAKE_RGB_MAP(_my_pic\w,_my_pic\h,_rgb_map\path)
EndIf
EndProcedure


Procedure __SAVE_RED()
_rgb_map\path=SaveFileRequester("SAVE RED MAP AS...:",_rgb_map\path,"*.red",0)
If _rgb_map\path>""
__MAKE_RED_MAP(_my_pic\w,_my_pic\h,_rgb_map\path)
EndIf
EndProcedure


Procedure __SAVE_GREEN()
_rgb_map\path=SaveFileRequester("SAVE GREEN MAP AS...:",_rgb_map\path,"*.green",0)
If _rgb_map\path>""
__MAKE_GREEN_MAP(_my_pic\w,_my_pic\h,_rgb_map\path)
EndIf
EndProcedure


Procedure __SAVE_BLUE()
_rgb_map\path=SaveFileRequester("SAVE BLUE MAP AS...:",_rgb_map\path,"*.blue",0)
If _rgb_map\path>""
__MAKE_BLUE_MAP(_my_pic\w,_my_pic\h,_rgb_map\path)
EndIf
EndProcedure


Procedure __OPEN_PICTURE()
_my_pic\file=OpenFileRequester("OPEN SOURCE PIC TO CONVERT",_my_pic\file,"*.*",0)
__ANALYSE_FILE(_my_pic\file)
EndProcedure




Procedure __GET_MENU_ENTRY(_val)
Define _dummy.b=0

Select EventMenu()

Case #_QUIT
__SET_STATE(#_END)

Case #_OPEN_PICTURE
__OPEN_PICTURE()

Case #_ABOUT
MessageRequester("ABOUT","Experimental Project To Create Topographic Data"+Chr(13)+" For Deutschmann Walter Game Projects"+Chr(13)+"(C) By Deutschmann Walter",#PB_MessageRequester_Ok)

Case #_MAKE_SCANMAP
__SAVE_RGB()

Case #_MAKE_REDMAP
__SAVE_RED()

Case #_MAKE_BLUEMAP
__SAVE_BLUE()

Case #_MAKE_GREENMAP
__SAVE_GREEN()

Case #_MAKE_AI_MAP


If MessageRequester("Attention:"," This Can Cause Millions Of Files."+Chr(10)+"Continue?",#PB_MessageRequester_YesNo)= #PB_MessageRequester_Yes
__SAVE_AI()
Else
_dummy.b=MessageRequester("Info:","Scan Apported. By User.",#PB_MessageRequester_Ok)
EndIf

Case #_MAKE_AI_DITHER_MAP

If MessageRequester("Info:"," This Will Create Basic RGB AI42 MAP."+Chr(10)+"Continue?",#PB_MessageRequester_YesNo)= #PB_MessageRequester_Yes
__SAVE_AI_DITHER()
Else
_dummy.b=MessageRequester("Info:","Scan Apported. By User.",#PB_MessageRequester_Ok)
EndIf


EndSelect


EndProcedure





Procedure __SET_STATE(_s)

_system_state=_s


Select _s

Case #_WAITING

_mt.b=#_WAITING ;multitasking on ;waiting for inputs..


Case #_BUSSY

_mt.b=#_BUSSY  ;get as much power of the system/cpu as you can!!!


EndSelect


EndProcedure


Procedure  __EVENT_HANDLER(_event)


Select _event


Case #PB_Event_Menu

If _mt=#_WAITING
__GET_MENU_ENTRY(_event)
Else
;nope
;nope
EndIf


EndSelect

; ExamineKeyboard()
; 
; If KeyboardPushed(#PB_Key_Subtract)
; _3d_offset-1
; _my_pic\scaled_w-1
; If _3d_offset<(0-DesktopWidth(0))
; _3d_offset=0
; EndIf
; EndIf
; 
; 
; 
; If KeyboardPushed(#PB_Key_Add)
; _3d_offset+1
; _my_pic\scaled_w+1
; If _3d_offset>DesktopWidth(0)
; _3d_offset=0
; EndIf
; EndIf



EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 28
; FirstLine = 2
; Folding = ----
; EnableXP
; EnableOnError
; CPU = 1
; SubSystem = DX9
; DisableDebugger
; HideErrorLog